{$APPTYPE CONSOLE}
{$MAXSTACKSIZE 32000000}

type
  TDirection = (drHorizontal, drVertical);

const
  MinLen = 3;
  di: array[TDirection] of integer = (0, 1);
  dj: array[TDirection] of integer = (1, 0);

var
  crossword: array[0..503, 0..503] of char;
  i, j, k, l, n, w, h, p: integer;
  direction: TDirection;
  c: ^char;
  s: string;
  fi, fo: text;

procedure Ex(s: string);
begin
  write(fo, s);
  CloseFile(fi);
  CloseFile(fo);
  halt(0);
end;

function CanWrite(var i, j: integer): boolean;
var k: integer;
begin
  Result := true;
  for k := 1 to MinLen-1 do
    Result := Result and (crossword[i+di[direction]*k, j+dj[direction]*k] <> '.');
end;

procedure next;
begin
  while (crossword[i, j] = '.') or ((crossword[i, j] <> '.') and
    not CanWrite(i, j)) or (crossword[i-di[direction], j-dj[direction]] <> '.') do
    begin
      inc(j);
      if j >= w+1 then
        begin
          j := 1;
          inc(i);
          if i >= h+1 then
            if direction = drHorizontal then
              begin
                direction := drVertical;
                i := 1; j := 1;
                next;
                exit;
              end
            else
              Ex(s);
        end;
    end;
  p := 1;
  while p <= l do
    begin
      c := @crossword[i+di[direction]*(p-1), j+dj[direction]*(p-1)];
      if ((c^ in ['a'..'z']) and (c^ <> s[p])) or (c^ = '.') then
        Ex(s)
      else
        c^ := s[p];
       inc(p);
    end;
  if crossword[i+di[direction]*l, j+dj[direction]*l] <> '.' then Ex(s);
  inc(j);
end;

begin
  FillChar(crossword, SizeOf(crossword), '.');
  AssignFile(fi, 'input.txt');
  AssignFile(fo, 'output.txt');
  reset(fi);
  rewrite(fo);
  readln(fi, w, h);
  for i := 1 to h do
    begin
      readln(fi, s);
      for j := 1 to w do
        crossword[i, j] := s[j];
    end;
  readln(fi, n);
  direction := drHorizontal;
  i := 1; j := 1;
  for k := 1 to n do
    begin
      readln(fi, s); l := length(s);
      next;
    end;
  Ex('CORRECT');
end.